<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <style>
        main{
            padding: 0;
            margin: 0;
            font-family: 'Lato';
            max-width: 500px;
            margin: 0 auto;  
        }
        
        .flex{
            display: flex;
        }
        
        .wrap{
            flex-wrap: wrap;
        }
        
        .center{
            justify-content: center;
        }
        .w20{
            width: 20%;    
        }
        .w90{
            width: 90%;
        }
        .w100{
            width: 100%;
        }
        
        .cel{
            height: 82px;
            z-index: 1;
            width: 90%;
            font-weight: bold;
            position: relative;
            margin: 5px auto;
            background-color: #1aa1f0;
            border-radius: 10px;    
            text-align: center;    
            justify-content: center;
            font-size: 2.25em;
        
            align-items: center;
        }
        
        .comprobar, .info{
            border: 1px solid #1aa1f0;
            border-radius: 5px;
            font-size: 1.2em;
            margin-bottom: 15px;
            margin-top: 15px;
        }
        
        .comprobar *, .info *{
            margin: 10px;
        }
        .info{
            border-color: crimson;
            background-color: crimson;
            color: white;
        }
        label{
            color: #1aa1f0;
            font-weight: bold;
        }
        input{
            box-sizing: border-box;
            width: 40%;    
            border: none;
            margin-bottom: 15px;
            font-size: 1.2em;
            padding: 10px;
            border-bottom: 2px solid #1aa1f0;
            outline: none;
            border-radius: 5px 5px 0 0;
        }
        
        input:focus, input:hover{    
            background-color: #BABABA;
        }
        
        
        button{
            width: 55%;
            padding: 15px;
            background-color: #1aa1f0;
            color: white;
            border: none;
            border-radius: 5px;
            font-size: 1.17em;
            margin-bottom: 10px;
        }
        
        button:hover, button:focus{    
            background-color: #1aa1f075;    
            cursor: pointer;
        }
        
        .celResult{
            height: 82px;
            z-index: 1;
            width: 90%;
            font-weight: bold;
            position: relative;
            margin: 5px auto;
            background-color: #BABABA;
            border-radius: 10px;    
            text-align: center;    
            justify-content: center;
            font-size: 2.25em;
            align-items: center;
        }
    </style>
    <title>Número secreto</title>
</head>

<body>
    <main>
        <h1>Adivina el número secreto</h1>
        <section id="codigo" class="flex wrap center">
            <div class="w100 flex wrap">
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
                <div class="w20">
                    <div class="cel flex">*</div>
                </div>
            </div>
        </section>
        <section class="w100 flex wrap center comprobar">
            <label class="w90" for="numero">Escribe aquí un número</label><br>
            <input class="w90" type="text" id="numero" name="numero" value="01234"><br>
            <button class="w90" id="check" onclick="Comprobar()">Comprobar</button>
            
        </section>
        <section class="w100 info">
        <p class="w90" id="info">Primer intento, suerte!</p>
        </section>
        <section id="Result" class="flex wrap center">
            <!-- Esto debereís generarlo más adelante por código -->
            <div class="rowResult w100 flex wrap">
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
            </div>



            <div class="rowResult w100 flex wrap">
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
                <div class="w20">
                    <div class="celResult flex"></div>
                </div>
            </div>
        </section>
    </main>
</body>

</html>

<script>
    const codigo = []; //NUMERORANDOM
    const maxIntento = 8; //MAXIntentos
    var count = 0; //Intentos
    var jugar = true;//Indica si el juego continua o no
    //Creamos constantes de las rutas para no llenar el codigo de pathings
    const rutaCodigoDiv = document.getElementById("codigo").getElementsByClassName("cel flex"); 
    
    /*1. Genera una constante CODIGO_SECRETO de tipo array de 5 número aleatorios entre 0 y 9 usando la libreria Math.random();*/
    function codigoSecreto() {
        for (let i = 0; i < 5; i++) {
            codigo[i] = Math.floor((Math.random() * 10));
            //console.log(codigo[i]);
        }
    
    }
    codigoSecreto();
    BeautyPage(); //Mejora la página a nivel visual
    
    //Esto sirve para al presionar ENTER te lea lo que has excrito en input.
    document.querySelector("input").addEventListener('keypress', function(event) {
        if (event.key === "Enter") {
            Comprobar();
        }
    });
    function Comprobar() {
        
        var numero = document.querySelector("input").value; //le damos el value a la variable numero
        var arrayNum = [];
        
        if(jugar && count <= 7){
            if(numero.length ==5 && !isNaN(numero)){           
                ComprobarNumero(numero, arrayNum);
                Comentario(); 
                count++;
                
            }else alert("Introduce un NUMERO de 5 dígitos");
        }
        
    }
    
    
    
    function ComprobarNumero(numero,  arrayNum) { 
        // Pone el numero que está correcto en la fila principal y nos mueve a la funcion CeldasGrises(),
        // 
    
        for(var i = 0; i<5;i++) {
            arrayNum[i] = numero[i];
            if(codigo[i] == numero[i]) rutaCodigoDiv[i].textContent = numero[i];
        }
        CeldasGrises(arrayNum);   
    }
    
    
    //Output del comentario
    function Comentario() {
        var section = document.getElementsByClassName("w100 info");
        var info = document.getElementById("info");
        LimpiarInput();
        if(count <6){
            info.textContent = "Es tu intento nº"+(count+2);
        }
        
        if (count==maxIntento-1){
            info.textContent = "PERDISTE";
            for(var i = 0; i<5;i++) {
                rutaCodigoDiv[i].textContent = codigo[i];
            }
        } 
    
        if(jugar == false){
            section[0].style.backgroundColor = "green";
            info.textContent = "HAS GANADO";
        }
        if (count == maxIntento-2) info.textContent = "Es tu último intento"
    }
    
    
    function LimpiarInput() {
        document.querySelector("input").value = ""; //Limpiamos el valor antiguo del input
        document.querySelector("input").focus(); //funcion de js que encontramos para no tener que volver a hacer clic
    }
    
    
    //Funcion que sirve de puente a las funciones que modifican el style y contenido de las celdas
    function CeldasGrises(arrayNum) {
        let fila = document.getElementsByClassName("rowResult w100 flex wrap");
        let celda = fila[count].getElementsByClassName("celResult flex");
    
        PosicionesIncorrectas(arrayNum, celda);
        
        PrintarNumeros(arrayNum, celda);
        
        //console.log(celda);
        if(count >= 1 && count < 8) CrearDiv();
        if(PosicionesCorrecta(arrayNum, celda)){
            jugar = false;
        }
    }
    
    
    function PosicionesCorrecta(arrayNum, celda){
        var correcto = true;
        for(var i = 0; i<celda.length;i++){       
            if(arrayNum[i] == codigo[i]) celda[i].style.backgroundColor = "green";
            else correcto = false;
            
        }
        return correcto;
    }
    
    
    function PosicionesIncorrectas(arrayNum, celda){
        for(var i = 0; i<celda.length;i++){
            celda[i].style.backgroundColor = "red";
            for(var j = 0; j<celda.length;j++){
                if(arrayNum[i] == codigo[j]) celda[i].style.backgroundColor = "yellow";
            }
        }
    }
    
    
    function PrintarNumeros(arrayNum, celda){
        for (i=0; i<celda.length;i++) {
            celda[i].textContent = arrayNum[i];
        }
    }
    
    function CrearDiv() 
    {
        if(count < 7)
        {
            var section = document.getElementById("Result"); //section
            
            var div = document.createElement("div"); ///fila
            div.setAttribute("class", "rowResult w100 flex wrap");
            section.appendChild(div);
            
            for(var i = 0; i<5;i++)
            {
                //console.log("pepe");
                var subdiv = document.createElement("div"); //celda
                subdiv.setAttribute("class", "w20");
                div.appendChild(subdiv);
    
                var divText = document.createElement("div");
                divText.setAttribute("class", "celResult flex");
                subdiv.appendChild(divText);
            }
        }
    
    }
    
    function BeautyPage(){
        document.querySelector("input").value = ""; //Quita los numeros de 01234 del inicio.
        document.querySelector("input").placeholder = "Introduce un numero..."; //Pone un texto por defecto no seleccionable.
        document.querySelector("input").maxLength = 5;
        CreateButton();
        LightMode();
        
    }
    
    //Creamos el boton de modo oscuro
    function CreateButton(){
        var main = document.querySelector("body");
        var nocturneButton = document.createElement("button");
        nocturneButton.setAttribute("id", "nocturne");
        nocturneButton.setAttribute("onclick", "NocturneMode()");
        main.appendChild(nocturneButton);
        nocturneButton.textContent = "Noche";
        nocturneButton.style.width = "100px";
        main.style.display = "flex";
        nocturneButton.style.flexDirection = "column";
        nocturneButton.style.height = "50px"
        
    }
    
    //Cambia al modo oscuro
    function NocturneMode(){
        document.querySelector("body").style.backgroundImage = "url('firewatch.png')";
        document.querySelector("h1").style.color = "white";
        var nocturneButton = document.getElementById("nocturne").setAttribute("onclick", "LightMode()");
        document.getElementById("nocturne").textContent = "Dia";
        
    }
    
    //Cambia al modo Dia
    function LightMode(){
        document.querySelector("body").style.backgroundImage = "url('f1.png')";
        document.querySelector("h1").style.color = "black";
        var nocturneButton = document.getElementById("nocturne").setAttribute("onclick", "NocturneMode()");
        document.getElementById("nocturne").textContent = "Noche";
    
    }
</script>

